<template>
<st-content :heading="tutoria.nombre">
  <st-back-btn/>
    <st-appointment 
    v-model="dialog" 
    @refreshData="refreshData" 
    :appointment="appoint" 
    :idUnitTutorship="tutoria.idUnidad"
    :key="componentKey"/>
    <v-row>
      <v-col>
        <st-tutorship-data
          :edit="false"
          :tutorshipName="tutoria.nombre"
          :tutorshipDescription="tutoria.descripcion"
          :tutorshipSessionsNumber="tutoria.numSesiones"
          :tutorshipType1="tutoria.tipoTutoria.tutorFijo"
            :tutorshipType2="tutoria.tipoTutoria.tutorAsignado"
            :tutorshipType3="tutoria.tipoTutoria.individual"
            :tutorshipType4="tutoria.tipoTutoria.obligatoria"/>
      </v-col>
    </v-row>
     <v-row>
      <v-col>
        <div class="content-body">
          <st-secondary-btn
            nombre="Registrar Cita"
            @click="open"
          ></st-secondary-btn>
        </div>
      </v-col>
    </v-row>
</st-content>
</template>

<script>
import RequestAppointment from "@/components/student/RequestAppointment";
import TutorshipDataSection from "@/components/TutorshipDataSection";
import timeFormat from "@/assets/js/time-format";

export default {
  data () {
    return {
      componentKey: 0,
      dialog: false,
      appoint: {},
      tutoria:{ nombre: '...Cargando', descripcion:'...Cargando', numSesiones: '...Cargando', 
      tipoTutoria: {
        tutorFijo : false,
        tutorAsignado: false,
        obligatorio : false,
        individual : false,
      }},
    }
  },
  mounted(){
    this.loadTutorship()
    this.loadSession()
  },
  components:{
    "st-appointment": RequestAppointment,
    "st-tutorship-data": TutorshipDataSection,
  },
  methods: {
    open(){
      this.componentKey += 1
      this.dialog = true
    },
    refreshData(){
      this.dialog = false
      this.loadSession()
    },
    async loadTutorship(){
      try{
        let { data: { data } } = await this.$api.getTutorship(this.$route.params.id)
        this.tutoria.nombre = data.nombre
        this.tutoria.descripcion = data.descripcion
        this.tutoria.numSesiones = data.numSesiones
        this.tutoria.idUnidad = data.idUnidad 
        this.tutoria.tipoTutoria = data.tipoTutoria
      } catch (e) {
          this.$store.commit('setError', e)
      }
    },
    async loadSession(){
      try{
        const idTutorship = this.$route.params.id
        const idStudent = this.$store.state.role.id
        let { data: { data:{alumno} } } = await this.$api.getStudentTutorshipSession(idTutorship, idStudent)
        let student = alumno
        student.fechaFormato = student.ultimaSesion ? timeFormat(student.ultimaSesion.fechaInicio) : '-';
        this.appoint = { student }
      } catch (e) {
          this.$store.commit('setError', e)
      }
    },
  }
}
</script>

<style scoped lang="scss">
</style>
